$ColorSub["Unu"]=57;

$LSGTypes=8;

$LSGTypeName[0]="Water";
$LSGTypeName[1]="Grass";
$LSGTypeName[2]="Beach";
$LSGTypeName[3]="Shallow Water";
$LSGTypeName[4]="Mountain Top";
$LSGTypeName[5]="Mountain Middle";
$LSGTypeName[6]="Mountain Lower";
$LSGTypeName[7]="Cave";

$ColorSub[0]=3;
$ColorSub[1]=2;
$ColorSub[2]=20;
$ColorSub[3]=14;
$ColorSub[4]=4;
$ColorSub[5]=5;
$ColorSub[6]=6;
$ColorSub[7]=5;

$HSub[0]=0;
$HSub[1]=1;
$HSub[2]=0;
$HSub[3]=0;
$HSub[4]=2;
$HSub[5]=3;
$HSub[6]=4;
$HSub[7]=0;

$LandSub[0]="~";
$LandSub[1]="+";
$LandSub[2]="-";
$LandSub[3]=".";
$LandSub[4]="/";
$LandSub[5]="^";
$LandSub[6]="\\";
$LandSub[7]=",";

$ILandSub["~"]=0;
$ILandSub["+"]=1;
$ILandSub["-"]=2;
$ILandSub["."]=3;
$ILandSub["/"]=4;
$ILandSub["^"]=5;
$ILandSub["\\"]=6;
$ILandSub[","]=7;

for(%i=0;%i<65&&1+0*(%a=getColorIDTable(%i));%i++)
{
	$ColorTable[%i]=%a;
}

function GenerateLandscapeData(%xm,%ym)
{
	%SO=new ScriptObject() {class=LandScapeSO;};
	%SO.X=%xm;
	%SO.Y=%ym;
	
	for(%y=0;%y<%ym;%y++)
	{
		for(%x=0;%x<%xm;%x++)
		{
			%SO.Scape[%x,%y]=0;
		}
	}
	
	return %SO;
}


function LandScapeSO::ProcessLandData(%this,%landnum,%mountnum,%loopnum,%seed)
{
	%this.PlaceRandom(%landnum,1);
	
	for(%i=0;%i<%loopnum-1;%i++)
	{
		echo(%i);
		%this.BuildAround(0,1,1,-1,%seed);
	}
	%this.BuildAround(0,1,1,-1,100);
	
	%this.BuildAround(0,2,1,1);
	%this.BuildAround(0,3,2,1);
	
	%this.PlaceRandom(%mountnum,6,1);
	%this.BuildAround(1,5,6,-1);
	%this.BuildAround(1,4,5,-1);
}

function LandScapeSO::IProcessLandData(%this,%watnum,%mountnum,%loopnum,%seed)
{
	%this.FillLandscape(1);
	
	%this.PlaceRandom(%watnum,0);
	
	for(%i=0;%i<%loopnum-1;%i++)
	{
		echo(%i);
		%this.BuildAround(1,0,0,-1,%seed);
	}
	%this.BuildAround(1,0,0,-1,100);
	
	%this.BuildAround(0,2,1,1);
	%this.BuildAround(0,3,2,1);
	
	%this.PlaceRandom(%mountnum,6,1);
	%this.BuildAround(1,5,6,-1);
	%this.BuildAround(1,4,5,-1);
}

function LandScapeSO::ProcessCaveData(%this,%cavnum,%mountnum,%loopnum,%seed)
{
	%this.FillLandscape(5);
	
	%this.PlaceRandom(%cavnum,7);
	
	for(%i=0;%i<%loopnum-1;%i++)
	{
		echo(%i);
		%this.BuildAround(5,7,7,-1,%seed);
	}
	%this.BuildAround(5,7,7,-1,100);
}

function LandscapeSO::FillLandscape(%this,%a)
{
	for(%y=0;%y<%this.y;%y++)
	{
		for(%x=0;%x<%this.x;%x++)
		{
			%this.Scape[%x,%y]=%a;
		}
	}
}

//%amt : Ammount of random spots
//%a : Changes to this
//[%b : Placed on this color]

function LandScapeSO::PlaceRandom(%this,%amt,%a,%b)
{
	%allowederrors=%amt*2;
	if(%b$="") {%ce=0;} else {%ce=1;}
	for(%i=0;%i<%amt;%i++)
	{
		%x=getRandom(0,%this.X-1);
		%y=getRandom(0,%this.Y-1);
		if(%ce)
		{
			if(%this.Scape[%x,%y]!=%b)
			{
				%i-=1;
				%errors++;
				if(%errors>%allowederrors)
				{
					break;
					echo("Error in landscape generation");
				}
				continue;
			}
		}
		%this.Scape[%x,%y]=%a;
	}
}

//%a : Changed from this
//%b : Changed to this
//%c : Should be near this
//[%d : Should be this if surrounded by %c]

function LandScapeSO::BuildAround(%this,%a,%b,%c,%d,%seed)
{
	if(%seed$="") {%seed=100;}
	for(%y=0;%y<%this.Y;%y++)
	{
		for(%x=0;%x<%this.X;%x++)
		{
			if(%this.Scape[%x,%y]!=%a) {%Scape[%x,%y]=%this.Scape[%x,%y];continue;}
			
			%up=%this.Scape[%x,%y+1];
			%down=%this.Scape[%x,%y-1];
			%left=%this.Scape[%x-1,%y];
			%right=%this.Scape[%x+1,%y];
			
			if(%d!=-1)
			{
				if(%up==%c&&%down==%c&&%left==%c&&%right==%c)
				{
					%Scape[%x,%y]=%d;
					continue;
				}
			}
			
			if(%up==%c)
			{
				if(getRandom(0,100)<=%seed)
				{
					%Scape[%x,%y]=%b;
					continue;
				}
			}
			
			if(%down==%c)
			{
				if(getRandom(0,100)<=%seed)
				{
					%Scape[%x,%y]=%b;
					continue;
				}
			}
			
			if(%left==%c)
			{
				if(getRandom(0,100)<=%seed)
				{
					%Scape[%x,%y]=%b;
					continue;
				}
			}
			
			if(%right==%c)
			{
				if(getRandom(0,100)<=%seed)
				{
					%Scape[%x,%y]=%b;
					continue;
				}
			}
			%Scape[%x,%y]=%this.Scape[%x,%y];
		}
	}
	
	for(%y=0;%y<%this.Y;%y++)
	{
		for(%x=0;%x<%this.X;%x++)
		{
			%this.Scape[%x,%y]=%Scape[%x,%y];
		}
	}
}

function LandScapeSO::PreviewLandscape(%this)
{
	LSG_Preview.clear();
	for(%y=0;%y<%this.Y;%y++)
	{
		for(%x=0;%x<%this.X;%x++)
		{
			LSG_Preview.addPixel(%x*16 SPC %y*16,$ColorTable[$ColorSub[%this.Scape[%x,%y]]]);
		}
	}
	LSG_Preview.resize(5,30,%this.X*16,%this.Y*16);
}

function BBZ(%count,%o)
{
	for(%i=0;%i<%count;%i++)
	{
		commandtoserver('plantbrick');
		commandtoserver('shiftbrick',0,0,%o);
	}
	commandtoserver('shiftbrick',0,0,-%count*%o);
}

function LandScapeSO::BuildLandscape(%this,%sx,%sy,%sz,%zcnt,%zo)
{
	if(%zcnt*1<=0) {%zcnt=1;%zo=0;}
	for(%y=0;%y<%this.Y;%y++)
	{
		for(%x=0;%x<%this.X;%x++)
		{
				commandtoserver('useSprayCan',$ColorSub["Unu"]);
				for(%i=0;%i<$HSub[%this.Scape[%x,%y]];%i++)
				{
					BBZ(%zcnt,%zo);
					commandtoserver('shiftbrick',0,0,%sz);
				}
				commandtoserver('useSprayCan',$ColorSub[%this.Scape[%x,%y]]);
				BBZ(%zcnt,%zo);
				commandtoserver('shiftbrick',%sx,0,-$HSub[%this.Scape[%x,%y]]*%sz);
		}
		commandtoserver('shiftbrick',-%this.X*%sx,%sy,0);
	}
}

function LandScapeSO::SaveLandscape(%this,%file)
{
	%fo=new FileObject();
	%fo.openForWrite(%file);
	%fo.writeLine(%this.x SPC %this.y);
	for(%y=0;%y<%this.Y;%y++)
	{
		%str="";
		for(%x=0;%x<%this.X;%x++)
		{
			%str=%str@$LandSub[%this.Scape[%x,%y]];
		}
		%fo.writeLine(%str);
	}
	%fo.close();
	%fo.delete();
}

function LoadLandscape(%file)
{
	%fo=new FileObject();
	%fo.openForRead(%file);
	%dim=%fo.readLine();
	%pos1=strpos(%dim,"(");
	%pos2=strpos(%dim,",");
	%pos3=strpos(%dim,")");
	%x=getSubStr(%dim,%pos1+1,%pos2-%pos1-1);
	%y=getSubStr(%dim,%pos2+1,%pos3-%pos2-1);
	%scape=GenerateLandScapeData(%x,%y);
	while(!%fo.isEOF())
	{
		%line=%fo.readLine();
		for(%i=0;%i<strLen(%line);%i++)
		{
			%char=getSubStr(%line,%i,1);
			%scape.Scape[%i,%yv]=$ILandSub[%char];
		}
		%yv++;
	}
	%fo.close();
	%fo.delete();
	return %scape;
}

//GUI

exec("./LSG_Gui.gui");
exec("./LSGPreviewGui.gui");
exec("./LSGCGui.gui");

if (!$LSGM)
{
	$remapDivision[$remapCount] = "Landscape Generator";
	$remapName[$remapCount] = "Open GUI";
	$remapCmd[$remapCount] = "LSG_OG";
	$remapCount++;
	$LSGM = true;
}

function LSG_OG()
{
	canvas.pushdialog(LSG_Gui);
}

function LSG_Gui::OnWake(%this)
{
	LSG_ReloadSettings();
}

function LSG_ReloadSettings()
{
	//Color Settings
	for(%i=0;%i<65&&1+0*(%a=getColorIDTable(%i));%i++)
	{
		$ColorTable[%i]=%a;
	}
	
	LSG_CS.clear();
	for(%i=0;%i<$LSGTypes;%i++)
	{
		%t=AddGuiText(5 SPC %i*20,$LSGTypeName[%i]@" ("@$LandSub[%i]@")");
		LSG_CS.add(%t);
		%b=AddColorButton(155 SPC %i*20,"18 18",$ColorTable[$ColorSub[%i]],"LSGGui_EditColor(\""@155 SPC %i*20@"\","@%i@");");
		LSG_CS.add(%b);
	}
	%t=AddGuiText(5 SPC %i*20,"----------");
	LSG_CS.add(%t);
	%i++;
	%t=AddGuiText(5 SPC %i*20,"Unused Land");
	LSG_CS.add(%t);
	%b=AddColorButton(155 SPC %i*20,"18 18",$ColorTable[$ColorSub["Unu"]],"LSGGui_EditColor(\""@155 SPC %i*20@"\","@"Unu"@");");
	LSG_CS.add(%b);
	LSG_RCS();
}

function AddColorButton(%pos,%ext,%col,%cmd)
{
	%n=new GuiSwatchCtrl()
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %pos;
		extent = %ext;
		minExtent = "8 2";
		visible = "1";
		color = %col;

		new GuiBitmapButtonCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = %ext;
			minExtent = "8 2";
			visible = "1";
			command = %cmd;
			text = " ";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "base/client/ui/btnColor";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
	};
	%n.setColor(%col);
	return %n;
}

function AddGuiText(%pos,%text)
{
	%t=new GuiTextCtrl()
	{
		profile = "GuiTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %pos;
		extent = "0 18";
		minExtent = "8 2";
		visible = "1";
		text = %text;
		maxLength = "255";
	};
	return %t;
}

function LSG_RCS()
{
	%maxx=0;
	%maxy=0;
	
	%cnt=LSG_CS.getCount();
	for(%i=0;%i<%cnt;%i++)
	{
		%obj=LSG_CS.getObject(%i);
		
		%pos=%obj.getPosition();
		%ext=%obj.getExtent();
		
		%x=getWord(%pos,0)+getWord(%ext,0);
		%y=getWord(%pos,1)+getWord(%ext,1);
		
		if(%x>%maxX) {%maxX=%x;}
		if(%y>%maxY) {%maxY=%y;}
	}
	
	LSG_CS.resize(0,0,%maxX,%maxY);
}

function LSGPreviewGui::onWake(%this)
{
	$Scape.previewLandScape();
}

function GuiSwatchCtrl::addPixel(%this,%pos,%col)
{
	%n=new GuiSwatchCtrl()
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %pos;
		extent = "16 16";
		minExtent = "8 2";
		visible = "1";
		color = %col;
	};%this.add(%n);
	%n.setColor(%col);
}

function LSGGui_Create(%x,%y)
{
	$Scape=GenerateLandscapeData(%x,%y);
}

function LSGGui_Generate(%ia,%ma,%lo,%gr)
{
	$Scape.ProcessLandData(%ia,%ma,%lo,%gr);
}

function LSGGui_Save(%file)
{
	$Scape.saveLandScape(%file);
}

function LSGGui_LoadLandscape(%file)
{
	$Scape=LoadLandscape(%file);
}

function LSGGui_Build()
{
	$Scape.BuildLandscape(LSG_XO.getValue(),LSG_YO.getValue(),LSG_ZO.getValue(),LSG_ZIC.getValue(),LSG_ZIO.getValue());
}

function LSGGui_EditColor(%pos,%ind)
{
	ShowLSGColorDlg(%ind,%pos);
}

function ShowLSGColorDLG(%ind,%pos)
{
	canvas.pushDialog(LSGCGui);
	LSGC_ReloadColors(%ind);
}

function LSGC_ReloadColors(%ind)
{
	LSGC_ColorList.clear();
	LSGC_ColorList.resize(0,0,128,128);
	%x=0;
	%y=0;
	for(%i=0;%i<64;%i++)
	{
		if(%x>7) {%x=0;%y++;}
		%b=AddColorButton(%x*16 SPC %y*16,"16 16",$ColorTable[%i],"CloseLSGColorDlg(\""@%ind@"\",\""@%i@"\");");
		LSGC_ColorList.add(%b);
		%x++;
	}
}

function CloseLSGColorDlg(%ind,%col)
{
	canvas.popDialog(LSGCGui);
	$ColorSub[%ind]=%col;
	LSG_ReloadSettings();
}